#define com_maroontress_libcgi_util_Tub_IMPORT

#include <ctype.h>
#include <com/maroontress/libcgi/util/Tub.h>
#include "URL.h"

static int
encodeComponent(struct Tub *tub, const char *s)
{
    char buf[4];
    int c;

    for (; *s != 0; ++s) {
	if (*s == ' ') {
	    if (Tub_writeByte(tub, '+') < 0) {
		return -1;
	    }
	}
	else if (isalnum(*s)) {
	    if (Tub_writeByte(tub, *s) < 0) {
		return -1;
	    }
	}
	else {
	    snprintf(buf, sizeof(buf), "%%%.2x", *s);
	    if (Tub_writeCString(tub, buf) < 0) {
		return -1;
	    }
	}
    }
    return Tub_writeByte(tub, 0);
}

char *
URL_encodeComponent(const char *s)
{
    struct Tub *tub;
    char *d;

    if ((tub = Tub_create()) == NULL)
	return NULL;
    d = ((encodeComponent(tub, s) < 0) ? NULL : Tub_createByteArray(tub));
    Tub_free(tub);
    return d;
}
